;Cybot test program - Nigel Goodwin Oct 2001


RHFor	equ	01
LHFor	equ	03
RHBak	equ	00
LHBak	equ	02

d1	equ	20
d2	equ	21
del	equ	22

	LIST	p=16F84 , r=dec
	include &quot;P16F84.inc&quot;
	__config H'3FF1' 


	org	0000
	goto 	start
	org	0004

; Subroutines

; call 100mS delay number of times in W
Delay	movwf	del
DelLoop	call 	Del100
	decfsz	del, f
	goto	DelLoop
	return

; 100mS delay
Del100	movlw	0x8d
	movwf	d1
Delay_00
	movlw	0xeb
	movwf	d2
Delay_01
	decfsz	d2, f
	goto	Delay_01
	decfsz	d1, f
	goto	Delay_00

			;25 cycles
	movlw	0x08
	movwf	d1
Delay_10
	decfsz	d1, f
	goto	Delay_10

			;1 cycles
	nop

			;4 cycles (including call)
	return


STOP		; stop both motors
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

FORWARD		; both motors forward
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bsf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

BACKWARD	; both motors backward
	bsf	PORTB,RHBak
	bsf	PORTB,LHBak
	bcf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

LEFT		; RH motor forwards
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bsf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

RIGHT		; LH motor forwards
	bcf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

SPINL		; RH motor forwards, LH motor backwards
	bcf	PORTB,RHBak
	bsf	PORTB,LHBak
	bsf	PORTB,RHFor
	bcf	PORTB,LHFor
	return

SPINR		; LH motor forwards, RH motor backwards
	bsf	PORTB,RHBak
	bcf	PORTB,LHBak
	bcf	PORTB,RHFor
	bsf	PORTB,LHFor
	return

; End of subroutines

; Start of main program

; Define port directions (all as outputs)
start	movlw 	0
	; set bank 1
	bsf	STATUS, RP0
	movwf	TRISB
	movwf	TRISA
	; set bank 0
	bcf	STATUS, RP0


; to call a delay, load the number of 1/10th seconds in W before the call
; the examples below all use 10 (0x0a hex) for a 1 second delay.

MAIN	call	STOP	;ensure all lines are turned off!.

	movlw	0x0a	;set delay to 1 second
	call	Delay	;allow time to place Cybot down
	call	FORWARD

	movlw	0x0a
	call	Delay
	call	STOP

	movlw	0x0a
	call	Delay
	call	BACKWARD

	movlw	0x0a
	call	Delay
	call	STOP

	movlw	0x0a
	call	Delay
	call	RIGHT

	movlw	0x0a
	call	Delay
	call	STOP

	movlw	0x0a
	call	Delay
	call	LEFT

	movlw	0x0a
	call	Delay
	call	STOP

	movlw	0x0a
	call	Delay
	call	SPINL

	movlw	0x0a
	call	Delay
	call	STOP

	movlw	0x0a
	call	Delay
	call	SPINR

	movlw	0x0a
	call	Delay
	goto	MAIN	;loop back to start and run for ever.

	END
